/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the ActivateOrBlockAccountResponse type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ActivateOrBlockAccountResponse{}

// ActivateOrBlockAccountResponse struct for ActivateOrBlockAccountResponse
type ActivateOrBlockAccountResponse struct {
	Account        *Account       `json:"account,omitempty"`
	NewPassword    NullableString `json:"newPassword,omitempty"`
	NewEdhPassword NullableString `json:"newEdhPassword,omitempty"`
}

// NewActivateOrBlockAccountResponse instantiates a new ActivateOrBlockAccountResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewActivateOrBlockAccountResponse() *ActivateOrBlockAccountResponse {
	this := ActivateOrBlockAccountResponse{}
	return &this
}

// NewActivateOrBlockAccountResponseWithDefaults instantiates a new ActivateOrBlockAccountResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewActivateOrBlockAccountResponseWithDefaults() *ActivateOrBlockAccountResponse {
	this := ActivateOrBlockAccountResponse{}
	return &this
}

// GetAccount returns the Account field value if set, zero value otherwise.
func (o *ActivateOrBlockAccountResponse) GetAccount() Account {
	if o == nil || IsNil(o.Account) {
		var ret Account
		return ret
	}
	return *o.Account
}

// GetAccountOk returns a tuple with the Account field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ActivateOrBlockAccountResponse) GetAccountOk() (*Account, bool) {
	if o == nil || IsNil(o.Account) {
		return nil, false
	}
	return o.Account, true
}

// HasAccount returns a boolean if a field has been set.
func (o *ActivateOrBlockAccountResponse) HasAccount() bool {
	if o != nil && !IsNil(o.Account) {
		return true
	}

	return false
}

// SetAccount gets a reference to the given Account and assigns it to the Account field.
func (o *ActivateOrBlockAccountResponse) SetAccount(v Account) {
	o.Account = &v
}

// GetNewPassword returns the NewPassword field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ActivateOrBlockAccountResponse) GetNewPassword() string {
	if o == nil || IsNil(o.NewPassword.Get()) {
		var ret string
		return ret
	}
	return *o.NewPassword.Get()
}

// GetNewPasswordOk returns a tuple with the NewPassword field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ActivateOrBlockAccountResponse) GetNewPasswordOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.NewPassword.Get(), o.NewPassword.IsSet()
}

// HasNewPassword returns a boolean if a field has been set.
func (o *ActivateOrBlockAccountResponse) HasNewPassword() bool {
	if o != nil && o.NewPassword.IsSet() {
		return true
	}

	return false
}

// SetNewPassword gets a reference to the given NullableString and assigns it to the NewPassword field.
func (o *ActivateOrBlockAccountResponse) SetNewPassword(v string) {
	o.NewPassword.Set(&v)
}

// SetNewPasswordNil sets the value for NewPassword to be an explicit nil
func (o *ActivateOrBlockAccountResponse) SetNewPasswordNil() {
	o.NewPassword.Set(nil)
}

// UnsetNewPassword ensures that no value is present for NewPassword, not even an explicit nil
func (o *ActivateOrBlockAccountResponse) UnsetNewPassword() {
	o.NewPassword.Unset()
}

// GetNewEdhPassword returns the NewEdhPassword field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ActivateOrBlockAccountResponse) GetNewEdhPassword() string {
	if o == nil || IsNil(o.NewEdhPassword.Get()) {
		var ret string
		return ret
	}
	return *o.NewEdhPassword.Get()
}

// GetNewEdhPasswordOk returns a tuple with the NewEdhPassword field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ActivateOrBlockAccountResponse) GetNewEdhPasswordOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.NewEdhPassword.Get(), o.NewEdhPassword.IsSet()
}

// HasNewEdhPassword returns a boolean if a field has been set.
func (o *ActivateOrBlockAccountResponse) HasNewEdhPassword() bool {
	if o != nil && o.NewEdhPassword.IsSet() {
		return true
	}

	return false
}

// SetNewEdhPassword gets a reference to the given NullableString and assigns it to the NewEdhPassword field.
func (o *ActivateOrBlockAccountResponse) SetNewEdhPassword(v string) {
	o.NewEdhPassword.Set(&v)
}

// SetNewEdhPasswordNil sets the value for NewEdhPassword to be an explicit nil
func (o *ActivateOrBlockAccountResponse) SetNewEdhPasswordNil() {
	o.NewEdhPassword.Set(nil)
}

// UnsetNewEdhPassword ensures that no value is present for NewEdhPassword, not even an explicit nil
func (o *ActivateOrBlockAccountResponse) UnsetNewEdhPassword() {
	o.NewEdhPassword.Unset()
}

func (o ActivateOrBlockAccountResponse) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ActivateOrBlockAccountResponse) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Account) {
		toSerialize["account"] = o.Account
	}
	if o.NewPassword.IsSet() {
		toSerialize["newPassword"] = o.NewPassword.Get()
	}
	if o.NewEdhPassword.IsSet() {
		toSerialize["newEdhPassword"] = o.NewEdhPassword.Get()
	}
	return toSerialize, nil
}

type NullableActivateOrBlockAccountResponse struct {
	value *ActivateOrBlockAccountResponse
	isSet bool
}

func (v NullableActivateOrBlockAccountResponse) Get() *ActivateOrBlockAccountResponse {
	return v.value
}

func (v *NullableActivateOrBlockAccountResponse) Set(val *ActivateOrBlockAccountResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableActivateOrBlockAccountResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableActivateOrBlockAccountResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableActivateOrBlockAccountResponse(val *ActivateOrBlockAccountResponse) *NullableActivateOrBlockAccountResponse {
	return &NullableActivateOrBlockAccountResponse{value: val, isSet: true}
}

func (v NullableActivateOrBlockAccountResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableActivateOrBlockAccountResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
